﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'B4Multingual B4A/B4J Generated Code
Private Sub Class_Globals
	Private ba_ As Object
	Private default_language_translation_ As string
	Private translationMap As Map
	Private oAJLocale As AJLocale
	Private oAJDateFormatSymbols As AJDateFormatSymbols
	Private oAJCalendar As AJCalendar
	Private oAJCurrency As AJCurrency
	Private oAJDateFormat As AJDateFormat
	'
#Region varSYMBOLS
	Private const clubs_ As Int = 0
	Private const currency_ As Int = 1
	Private const currency_symbol_ As Int = 2
	Private const current_language_ As Int = 3
	Private const diamonds_ As Int = 4
	Private const first_week_day_ As Int = 5
	Private const hearts_ As Int = 6
	Private const planets_ As Int = 7
	Private const select_lang_ As Int = 8
	Private const select_month_ As Int = 9
	Private const select_weekday_ As Int = 10
	Private const spades_ As Int = 11
	Private const suits_ As Int = 12
	Private const title_ As Int = 13
	Private const trans_with_var_values_ As Int = 14
	Private const variable_message_ As Int = 15
	Private const car_p_ As Int = 16
	Private const planets_a_ As Int = 17
#End Region varSYMBOLS

#Region varLOCALES
	Private const EN As string = "en" 'English:Default Language
	Private const FR As string = "fr" 'French
	Private const IT As string = "it" 'Italian
#End Region varLOCALES
End Sub

#Region Initialize Methods
Private Sub InternalInitialize(ba As Object)
	Dim r As Reflector
	r.Target = Me
	r.Runmethod4("innerInitialize", Array As Object(ba), Array As String("anywheresoftware.b4a.BA"))
	ba_ = ba
End Sub

Public Sub Initialize
	ba_ = ba
	PopulateTranslate
	oAJLocale.InitializeDefault(ba)
	SetHelperClasses(oAJLocale.Locale)

	default_language_translation_ = EN
End Sub

Public Sub Initialize2(ba As Object, default_language_translation As String)
	InternalInitialize(ba)
	'
	PopulateTranslate
	oAJLocale.InitializeDefault(ba)
	SetHelperClasses(oAJLocale.Locale)

	default_language_translation_ = default_language_translation
End Sub

Private Sub SetHelperClasses(Locale As JavaObject)
	oAJDateFormatSymbols.Initialize2(ba_, Locale)
	oAJCalendar.Initialize
	oAJCalendar.GetInstance2(Locale)
	oAJDateFormat.Initialize
	oAJDateFormat.GetDateInstance3(oAJDateFormat.DEFAULT, Locale)
	oAJDateFormat.SetCalendar(oAJCalendar.Calendar)
	Try
		oAJCurrency.Initialize(Locale)
	Catch 
		Log(LastException)
	End Try
End Sub
#End Region Initialize Methods

#Region LOCALES
Public Sub getEnglish As String
	Return EN
End Sub
Public Sub getFrench As String
	Return FR
End Sub
Public Sub getItalian As String
	Return IT
End Sub
#End Region LOCALES

#Region KEYS
Public Sub getclubs As String
	Return Get_(clubs_)
End Sub
Public Sub getcurrency As String
	Return Get_(currency_)
End Sub
Public Sub getcurrency_symbol As String
	Return Get_(currency_symbol_)
End Sub
Public Sub getcurrent_language As String
	Return Get_(current_language_)
End Sub
Public Sub getdiamonds As String
	Return Get_(diamonds_)
End Sub
Public Sub getfirst_week_day As String
	Return Get_(first_week_day_)
End Sub
Public Sub gethearts As String
	Return Get_(hearts_)
End Sub
Public Sub getplanets As String
	Return Get_(planets_)
End Sub
Public Sub getselect_lang As String
	Return Get_(select_lang_)
End Sub
Public Sub getselect_month As String
	Return Get_(select_month_)
End Sub
Public Sub getselect_weekday As String
	Return Get_(select_weekday_)
End Sub
Public Sub getspades As String
	Return Get_(spades_)
End Sub
Public Sub getsuits As String
	Return Get_(suits_)
End Sub
Public Sub gettitle As String
	Return Get_(title_)
End Sub
Public Sub gettrans_with_var_values As String
	Return Get_(trans_with_var_values_)
End Sub
Public Sub getvariable_message As String
	Return Get_(variable_message_)
End Sub
Public Sub getcar_pMap As Map
	Return GetMap_(car_p_)
End Sub
Public Sub getplanets_aMap As Map
	Return GetMap_(planets_a_)
End Sub
#End Region KEYS

#Region Public Methods
Public Sub getAJLocale As AJLocale
	Return oAJLocale
End Sub

Public Sub setAJLocale(AJLocale As AJLocale)
	oAJLocale = AJLocale
	SetHelperClasses(oAJLocale.Locale)
End Sub

Public Sub getAJDateFormatSymbols As AJDateFormatSymbols
	Return oAJDateFormatSymbols
End Sub

Public Sub getAJCalendar As AJCalendar
	Return oAJCalendar
End Sub

Public Sub getAJCurrency As AJCurrency
	Return oAJCurrency
End Sub

Public Sub setAJCurrency(AJCurrency As AJCurrency)
	oAJCurrency = AJCurrency
End Sub

Public Sub getAJDateFormat As AJDateFormat
	Return oAJDateFormat
End Sub

Private Sub Get_(symbol As Int) As String
	Return Get(symbol, oAJLocale.GetLanguage)
End Sub

Public Sub Get(symbol As Int, lang As String) As String
	Dim line_map As Map
	line_map = translationMap.Get(symbol)
	Return(line_map.GetDefault(lang, line_map.Get(default_language_translation_)))
End Sub

Private Sub GetMap_(symbol As Int) As Map
	Return GetMap(symbol, oAJLocale.GetLanguage)
End Sub

Public Sub GetMap(symbol As Int, lang As String) As Map
	Dim lines_map As Map
	lines_map = translationMap.Get(symbol)
	Return lines_map.GetDefault(lang, lines_map.Get(default_language_translation_))
End Sub
#End Region Public Methods

Private Sub PopulateTranslate
	Dim line_map As Map
	Dim lines_map As Map
	translationMap.Initialize

	'0: CLUBS
	line_map.Initialize
	line_map.Put(EN,"Clubs")
	line_map.Put(FR,"Trèfle")
	line_map.Put(IT,"Club")
	translationMap.Put(clubs_, line_map)

	'1: CURRENCY
	line_map.Initialize
	line_map.Put(EN,"Currency")
	line_map.Put(FR,"Devise")
	line_map.Put(IT,"Valuta")
	translationMap.Put(currency_, line_map)

	'2: CURRENCY_SYMBOL
	line_map.Initialize
	line_map.Put(EN,"Currency Symbol")
	line_map.Put(FR,"Symbole monétaire")
	line_map.Put(IT,"Simbolo di valuta")
	translationMap.Put(currency_symbol_, line_map)

	'3: CURRENT_LANGUAGE
	line_map.Initialize
	line_map.Put(EN,"Current Language")
	line_map.Put(FR,"Langage courant")
	line_map.Put(IT,"Lingua corrente")
	translationMap.Put(current_language_, line_map)

	'4: DIAMONDS
	line_map.Initialize
	line_map.Put(EN,"Diamonds")
	line_map.Put(FR,"Carreau")
	line_map.Put(IT,"Diamanti")
	translationMap.Put(diamonds_, line_map)

	'5: FIRST_WEEK_DAY
	line_map.Initialize
	line_map.Put(EN,"First day of week")
	line_map.Put(FR,"1er  jour de la semaine")
	line_map.Put(IT,"Primo giorno della settimana")
	translationMap.Put(first_week_day_, line_map)

	'6: HEARTS
	line_map.Initialize
	line_map.Put(EN,"Hearts")
	line_map.Put(FR,"Coeur")
	line_map.Put(IT,"Cuori")
	translationMap.Put(hearts_, line_map)

	'7: PLANETS
	line_map.Initialize
	line_map.Put(EN,"Planets")
	line_map.Put(FR,"Planètes")
	line_map.Put(IT,"Pianeti")
	translationMap.Put(planets_, line_map)

	'8: SELECT_LANG
	line_map.Initialize
	line_map.Put(EN,"Select Language")
	line_map.Put(FR,"Choisir une langue")
	line_map.Put(IT,"Selezionare lingua")
	translationMap.Put(select_lang_, line_map)

	'9: SELECT_MONTH
	line_map.Initialize
	line_map.Put(EN,"Select Month")
	line_map.Put(FR,"Choisir le mois")
	line_map.Put(IT,"Selezionare il mese")
	translationMap.Put(select_month_, line_map)

	'10: SELECT_WEEKDAY
	line_map.Initialize
	line_map.Put(EN,"Select Weekday")
	line_map.Put(FR,"Choisir le jour de la semaine")
	line_map.Put(IT,"Selezionare il giorno della settimana")
	translationMap.Put(select_weekday_, line_map)

	'11: SPADES
	line_map.Initialize
	line_map.Put(EN,"Spades")
	line_map.Put(FR,"Pique")
	line_map.Put(IT,"Picche")
	translationMap.Put(spades_, line_map)

	'12: SUITS
	line_map.Initialize
	line_map.Put(EN,"Suits")
	line_map.Put(FR,"Couleurs")
	line_map.Put(IT,"Colore")
	translationMap.Put(suits_, line_map)

	'13: TITLE
	line_map.Initialize
	line_map.Put(EN,"Title")
	line_map.Put(FR,"Titre")
	line_map.Put(IT,"Titolo")
	translationMap.Put(title_, line_map)

	'14: TRANS_WITH_VAR_VALUES
	line_map.Initialize
	line_map.Put(EN,"Translation with variable values")
	line_map.Put(FR,"Traduction avec les valeurs des variables")
	line_map.Put(IT,"Traduzione con i valori delle variabili")
	translationMap.Put(trans_with_var_values_, line_map)

	'15: VARIABLE_MESSAGE
	line_map.Initialize
	line_map.Put(EN,"You are in %1$s and your Currency is %2$s")
	line_map.Put(FR,"Vous êtes en %1$s et votre monnaie est %2$s")
	line_map.Put(IT,"Sei in %1$s e la valuta è %2$s")
	translationMap.Put(variable_message_, line_map)

	'16: PLANETS_A (string-srray)
	lines_map.Initialize
	line_map.Initialize
	line_map.Put(0, "Mercury")
	line_map.Put(1, "Venus")
	line_map.Put(2, "Earth")
	line_map.Put(3, "Mars")
	line_map.Put(4, "Jupiter")
	line_map.Put(5, "Saturn")
	line_map.Put(6, "Uranus")
	line_map.Put(7, "Neptune")
	lines_map.Put(EN, line_map)

	line_map.Initialize
	line_map.Put(0, "Mercure")
	line_map.Put(1, "Venus")
	line_map.Put(2, "Terre")
	line_map.Put(3, "Mars")
	line_map.Put(4, "Jupiter")
	line_map.Put(5, "Saturne")
	line_map.Put(6, "Uranus")
	line_map.Put(7, "Neptune")
	lines_map.Put(FR, line_map)

	line_map.Initialize
	line_map.Put(0, "Mercurio")
	line_map.Put(1, "Venus")
	line_map.Put(2, "Terra")
	line_map.Put(3, "Marzo")
	line_map.Put(4, "Giove")
	line_map.Put(5, "Saturno")
	line_map.Put(6, "Urano")
	line_map.Put(7, "Nettuno")
	lines_map.Put(IT, line_map)
	translationMap.Put(planets_a_, lines_map)

	'17: CAR_P (plurals-array)
	lines_map.Initialize
	line_map.Initialize
	line_map.Put("one", "car")
	line_map.Put("other", "cars")
	lines_map.Put(EN, line_map)

	line_map.Initialize
	line_map.Put("one", "voiture")
	line_map.Put("other", "voitures")
	lines_map.Put(FR, line_map)

	line_map.Initialize
	line_map.Put("one", "auto")
	line_map.Put("other", "Automobili")
	lines_map.Put(IT, line_map)
	translationMap.Put(car_p_, lines_map)
End Sub